package timeTable.dataStructures;

import java.io.Serializable;

public class Availability implements Serializable
{
    static private final long serialVersionUID = 52L;

    /*************************************************/

    private Student student;

    /*************************************************/

    private TimeInterval timeInterval;

    /*************************************************/

    private boolean chosen;

    /*************************************************/
    
    public Availability(Student student, TimeInterval timeInterval)
    {
	this.student = student;
	this.timeInterval = timeInterval;
	student.addAvailability(this);
	timeInterval.addAvailability(this);
	chosen = false;
    }

    /*************************************************/

    public Student getStudent()
    {
	return student;
    }
    
    /*************************************************/
    
    public TimeInterval getTimeInterval()
    {
	return timeInterval;
    }

    /*************************************************/
    
    public int getStudentIndex()
    {
	return getStudent().getIndex();
    }

    /*************************************************/
    
    public void chose()
    {	
	if (!chosen)
	    {
		chosen = true;
		getStudent().setChosenAvailability(this);
		getTimeInterval().setChosenAvailability(this);
	    }
    }

    /*************************************************/
    
    public boolean isChosen()
    {
	return chosen;
    }

    /*************************************************/
    
    public void unChose()
    {
	if (chosen)
	    {
		chosen = false;
		getStudent().setChosenAvailability(null);
		getTimeInterval().setChosenAvailability(null);
	    }
    }
    
    /*************************************************/
    
    public int getTimeIntervalIndex()
    {
	return getTimeInterval().getIndex();
    }

    /*************************************************/
    
    public String toString()
    {
	return "(" + student.getName() + ", " 
	    + timeInterval + ", " + chosen + ")";  
    }
}
