package timeTable.dataStructures;

import java.util.Vector;
import java.io.Serializable;

public class Student implements Serializable
{
    static private final long serialVersionUID = 62L;

    /*************************************************/

    private int index;
    
    /*************************************************/

    private String name;
    
    /*************************************************/

    private Vector<Availability> availabilities;

    /*************************************************/
    
    private Availability chosenAvailability = null;
    
    /*************************************************/

    public Student(int index, String name)
    {
	this.name = name;
	this.index = index;
	availabilities = new Vector<Availability>();
    }
    
    /*************************************************/

    public int getIndex()
    {
	return index;
    }

    /*************************************************/

    public String getName()
    {
	return name;
    }

    /*************************************************/

    public void setName(String name)
    {
	this.name = name;
    }

    /*************************************************/

    public void addAvailability(Availability availability)
    {
	availabilities.add(availability);
    }

    /*************************************************/

    public void removeAvailability(Availability availability)
    {
	if (availability == chosenAvailability)
	    availability.unChose();
    }

    /*************************************************/

    public boolean isAvailable(TimeInterval timeInterval)
    {
	for (Availability availability : availabilities)
	    {
		if (availability.getTimeInterval() == timeInterval)
		    return true;
	    }
	return false;
    }

    /*************************************************/

    public void setChosenAvailability(Availability chosenAvailability)
    {
	if (this.chosenAvailability != chosenAvailability)
	    {
		if (this.chosenAvailability != null)
		    {
			Availability tmp = this.chosenAvailability;
			this.chosenAvailability = null;
			tmp.unChose();
		    }
		this.chosenAvailability = chosenAvailability;
		if (this.chosenAvailability != null)
		    this.chosenAvailability.chose();
	    }
    }

    /*************************************************/

    public Availability getChosenAvailability()
    {
	return chosenAvailability;
    }

    /*************************************************/

    public TimeInterval getChosenTimeInterval()
    {
	if (getChosenAvailability() == null)
	    return null;
	return getChosenAvailability().getTimeInterval();
    }

    /*************************************************/

    public String toString()
    {
	return name + "(" + availabilities  + ")";
    }    
}
