package timeTable.dataStructures;

import java.util.Vector;
import java.io.Serializable;

public class TimeInterval implements Serializable
{
    static private final long serialVersionUID = 72L;

    /*************************************************/

    private int index;    

    /*************************************************/

    private String name;    

    /*************************************************/

    private Vector<Availability> availabilities;

    /*************************************************/
    
    private Availability chosenAvailability;

    /*************************************************/
    
    public TimeInterval(int index, String name)
    {
	this.index = index;
	this.name = name;
	availabilities = new Vector<Availability>();	
	chosenAvailability = null;	
    }
    
    /*************************************************/
    
    public int getIndex()
    {
	return index;
    }

    /*************************************************/
    
    public String getName()
    {
	return name;
    }

    /*************************************************/
    
    public void setName(String name)
    {
	this.name = name;
    }

    /*************************************************/
    
    public void addAvailability(Availability availability)
    {
	availabilities.add(availability);
    }    

    /*************************************************/

    public void removeAvailability(Availability availability)
    {
	if (availability == chosenAvailability)
	    availability.unChose();
	availabilities.remove(availability);
    }

    /*************************************************/

    public void setChosenAvailability(Availability chosenAvailability)
    {
	if (this.chosenAvailability != chosenAvailability)
	    {
		if (this.chosenAvailability != null)
		    {
			Availability tmp = this.chosenAvailability;
			this.chosenAvailability = null;
			tmp.unChose();
		    }
		this.chosenAvailability = chosenAvailability;
		if (this.chosenAvailability != null)
		    this.chosenAvailability.chose();
	    }
    }

    /*************************************************/

    public Availability getChosenAvailability()
    {
	return chosenAvailability;
    }

    /*************************************************/
    
    public String toString()
    {
	return name;
    }
}
