package timeTable.view;

import timeTable.dataStructures.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import java.util.Vector;

public class Domino extends JFrame
{
    static private final long serialVersionUID = 32L;

    /**********************************************************************/
    
    private TimeTable t;

    /**********************************************************************/
    
    private Vector<Vector<JCheckBox>> cells;

    /**********************************************************************/
    
    private Vector<JLabel> students;

    /**********************************************************************/
    
    private Vector<JLabel> timeIntervals;
    
    /**********************************************************************/
    
    final private Color defaultColor = null;
    
    /**********************************************************************/
    
    public Domino(TimeTable t)
    {
	this.t = t;
	createWindow();
    }
    
    /**********************************************************************/
    
    private void changeStudentName(int index)
    {
	final JFrame jframe = new JFrame();
	jframe.setTitle("Domino");
        jframe.setSize(500, 120);
        jframe.setResizable(false);
	jframe.getContentPane().setLayout(new FlowLayout());
	jframe.getContentPane().add(new JLabel("Name of the student "));
	final JTextField nameOfTheStudent = new JTextField(t.getStudents().get(index).getName(), 40);
	jframe.getContentPane().add(nameOfTheStudent);
	JButton cancelButton = new JButton("Cancel");
	cancelButton.addActionListener
	    (
	     new ActionListener()
	     {
		 public void actionPerformed(ActionEvent e)
		 {
		     setEnabled(true);
		     jframe.dispose();
		 }
	     }
	     );
	JButton okayButton = new JButton("OK");
	final int indexFinal = index;
	okayButton.addActionListener
	    (
	     new ActionListener()
	     {
		 public void actionPerformed(ActionEvent e)
		 {
		     try
			 {
			     t.getStudents().get(indexFinal).setName(nameOfTheStudent.getText());
			     initWindow();
			     validate();
			     repaint();
			     setEnabled(true);
			     jframe.dispose();
			 }
		     catch(Exception f)
			 {
			     System.out.println(f);
			     f.printStackTrace();
			     JOptionPane.showMessageDialog
				 (null,"Invalid data");
			 }
		 }
	     }
	     );
	jframe.getContentPane().add(cancelButton);
	jframe.getContentPane().add(okayButton);
	jframe.setVisible(true);
	setEnabled(false);	
    }

   /**********************************************************************/
    
    private void changeTimeIntervalName(int index)
    {
	final JFrame jframe = new JFrame();
	jframe.setTitle("Domino");
        jframe.setSize(500, 120);
        jframe.setResizable(false);
	jframe.getContentPane().setLayout(new FlowLayout());
	jframe.getContentPane().add(new JLabel("Name of the time interval "));
	final JTextField nameOfTheTimeInterval = new JTextField(t.getTimeIntervals().get(index).getName(), 40);
	jframe.getContentPane().add(nameOfTheTimeInterval);
	JButton cancelButton = new JButton("Cancel");
	cancelButton.addActionListener
	    (
	     new ActionListener()
	     {
		 public void actionPerformed(ActionEvent e)
		 {
		     setEnabled(true);
		     jframe.dispose();
		 }
	     }
	     );
	JButton okayButton = new JButton("OK");
	final int indexFinal = index;
	okayButton.addActionListener
	    (
	     new ActionListener()
	     {
		 public void actionPerformed(ActionEvent e)
		 {
		     try
			 {
			     t.getTimeIntervals().get(indexFinal).setName(nameOfTheTimeInterval.getText());
			     initWindow();
			     validate();
			     repaint();
			     setEnabled(true);
			     jframe.dispose();
			 }
		     catch(Exception f)
			 {
			     System.out.println(f);
			     f.printStackTrace();
			     JOptionPane.showMessageDialog
				 (null,"Invalid data");
			 }
		 }
	     }
	     );
	jframe.getContentPane().add(cancelButton);
	jframe.getContentPane().add(okayButton);
	jframe.setVisible(true);
	setEnabled(false);	
    }

    /**********************************************************************/
    
    private void changeNumberOfStudents()
    {
	final JFrame jframe = new JFrame();
	jframe.setTitle("Domino");	
        jframe.setSize(200, 150);
        jframe.setResizable(false);
	jframe.getContentPane().setLayout(new FlowLayout());
	jframe.getContentPane().add(new JLabel("Number of students "));
	final JTextField numberOfStudents = new JTextField("" + t.getStudents().size(), 10);
	jframe.getContentPane().add(numberOfStudents);
	JButton cancelButton = new JButton("Cancel");
	cancelButton.addActionListener
	    (
	     new ActionListener()
	     {
		 public void actionPerformed(ActionEvent e)
		 {
		     setEnabled(true);
		     jframe.dispose();
		 }
	     }
	     );
	JButton okayButton = new JButton("OK");
	okayButton.addActionListener
	    (
	     new ActionListener()
	     {
		 public void actionPerformed(ActionEvent e)
		 {
		     try
			 {
			     t.changeNumberOfStudents(Integer.parseInt(numberOfStudents.getText()));
			     initWindow();
			     validate();
			     repaint();
			     setEnabled(true);
			     jframe.dispose();
			 }
		     catch(Exception f)
			 {
			     System.out.println(f);
			     f.printStackTrace();
			     JOptionPane.showMessageDialog
				 (null,"Invalid data");
			 }
		 }
	     }
	     );
	jframe.getContentPane().add(cancelButton);
	jframe.getContentPane().add(okayButton);
	jframe.setVisible(true);
	setEnabled(false);
    }
    
    /**********************************************************************/
    
    private void changeNumberOfTimeIntervals()
    {
	final JFrame jframe = new JFrame();
	jframe.setTitle("Domino");	
        jframe.setSize(200, 150);
        jframe.setResizable(false);
	jframe.getContentPane().setLayout(new FlowLayout());
	jframe.getContentPane().add(new JLabel("Number of time intervals "));
	final JTextField numberOfTimeIntervals = new JTextField("" + t.getTimeIntervals().size(), 10);
	jframe.getContentPane().add(numberOfTimeIntervals);
	JButton cancelButton = new JButton("Cancel");
	cancelButton.addActionListener
	    (
	     new ActionListener()
	     {
		 public void actionPerformed(ActionEvent e)
		 {
		     setEnabled(true);
		     jframe.dispose();
		 }
	     }
	     );
	JButton okayButton = new JButton("OK");
	okayButton.addActionListener
	    (
	     new ActionListener()
	     {
		 public void actionPerformed(ActionEvent e)
		 {
		     try
			 {
			     t.changeNumberOfTimeIntervals(Integer.parseInt(numberOfTimeIntervals.getText()));
			     initWindow();
			     validate();
			     repaint();
			     setEnabled(true);
			     jframe.dispose();
			 }
		     catch(Exception f)
			 {
			     System.out.println(f);
			     f.printStackTrace();
			     JOptionPane.showMessageDialog
				 (null,"Invalid data");
			 }
		 }
	     }
	     );
	jframe.getContentPane().add(cancelButton);
	jframe.getContentPane().add(okayButton);
	jframe.setVisible(true);
	setEnabled(false);
    }
    
    /**********************************************************************/
    
    private void colonnes(JPanel panel)
    {
	JLabel title = new JLabel("D");
	title.setToolTipText("Domino");
	Color defaultColor = title.getBackground();
	panel.add(title, 0, 0);
	for (int i = 0 ; i < t.getTimeIntervals().size() ; i++)
	    {
		final int finalI = i;
		JLabel label = new JLabel
		    (t.getTimeIntervals().get(i).toString().substring(0, 2));
		label.setToolTipText(t.getTimeIntervals().get(i).toString());
		label.addMouseListener
		    (
		     new MouseAdapter()
		     {
			 public void mouseClicked(MouseEvent e)
			 {
			     changeTimeIntervalName(finalI);
			 }
		     }
		     );
		timeIntervals.add(label);
		panel.add(label);
		label.setOpaque(true);
	    }
    }

    /**********************************************************************/
    
    private void updateColors()
    {
	for (int i = 0 ; i < t.getStudents().size() ; i++)
	    {
		students.get(i).setForeground(Color.BLACK);
		for (int j = 0 ; j < t.getTimeIntervals().size() ; j++)
		    {
			if(t.getStudents().get(i).getChosenTimeInterval() 
			   == t.getTimeIntervals().get(j))
			    {
				cells.get(i).get(j).setBackground(Color.RED);
				students.get(i).setForeground(Color.RED);	
			    }
			else
			    cells.get(i).get(j).setBackground(defaultColor);
		    }
	    }
    }

    /**********************************************************************/
    
    private JPanel makeGrid()
    {
	JPanel gPanel = new JPanel();
	gPanel.setLayout
	    (new GridLayout
	     (t.getStudents().size() + 1, 
	      t.getTimeIntervals().size() + 1
	      )
	     );	
	colonnes(gPanel);
	gPanel.setSize(5*(t.getTimeIntervals().size() + 1), 5*(t.getStudents().size() + 1));
	cells = new  Vector<Vector<JCheckBox>>();
	for (int i = 0 ; i < t.getStudents().size() ; i++)
	    {
		final int finalI = i;
		final JLabel studentLabel = new JLabel
		    (t.getStudents().get(i).toString().substring(0, 2));
		studentLabel.setToolTipText(t.getStudents().get(i).toString());
		studentLabel.addMouseListener
		    (
		     new MouseAdapter()
		     {
			 public void mouseClicked(MouseEvent e)
			 {
			     changeStudentName(finalI);
			 }
		     }
		     );
		students.add(studentLabel);
		gPanel.add(studentLabel);
		studentLabel.setOpaque(true);
		cells.add(new Vector<JCheckBox>());
		for (int j = 0 ; j < t.getTimeIntervals().size() ; j++)
		    {
			final JCheckBox cb = new JCheckBox();
			final JLabel timeIntervalLabel = timeIntervals.get(j);
			final int studentIndex = i;
			final int timeIntervalIndex = j;
			cb.addMouseListener
			    (
			     new MouseAdapter()
			     {
				 public void mouseEntered(MouseEvent e) 
				 {
				     studentLabel.setBackground(Color.BLUE);
				     timeIntervalLabel.setBackground(Color.BLUE);				     
				 }				 
				 
				 public void mouseExited(MouseEvent e)  
				 {
				     studentLabel.setBackground(defaultColor);
				     timeIntervalLabel.setBackground(defaultColor);
				 }
			     }
			     );
			cb.addActionListener
			    (
			     new ActionListener()
			     {
				 public void actionPerformed(ActionEvent e)
				 {
				     if (cb.isSelected())
					 t.addAvailability(studentIndex, timeIntervalIndex);
				     else
					 t.removeAvailability(studentIndex, timeIntervalIndex);
				     updateColors();
				 }
			     }
			     );
			cells.get(i).add(cb);
			gPanel.add(cb);
			cb.setSelected
			    (t.getStudents().get(i).isAvailable
			     (t.getTimeIntervals().get(j))
			     );
			cb.setToolTipText(t.getStudents().get(i).getName() + " " + t.getTimeIntervals().get(j).toString());
		    }
	    }
	updateColors();	
	return gPanel;
    }

    /**********************************************************************/
    
    private JPanel addButtons()
    {
	JPanel panel = new JPanel();
	panel.setLayout(new GridLayout(1, 3));
	JButton quitButton = new JButton("Quit without saving");
        quitButton.addActionListener
            (
             new ActionListener()
             {
                 public void actionPerformed(ActionEvent e)
                 {
                     dispose();
                 }
             }
             );
        panel.add(quitButton);
	JButton quitAndSaveButton = new JButton("Save and quit");
	quitAndSaveButton.addActionListener
            (
             new ActionListener()
             {
                 public void actionPerformed(ActionEvent e)
                 {
                     t.writeObject();
                     dispose();
                 }
             }
             );
        panel.add(quitAndSaveButton);
	JButton studentsButton = new JButton("Edit number of students");
	studentsButton.addActionListener
            (
             new ActionListener()
             {
                 public void actionPerformed(ActionEvent e)
                 {
		     changeNumberOfStudents();
                 }
             }
             );
	panel.add(studentsButton);
	JButton timeIntervalsButton = new JButton("Edit number of time intervals");
	timeIntervalsButton.addActionListener
            (
             new ActionListener()
             {
                 public void actionPerformed(ActionEvent e)
                 {
		     changeNumberOfTimeIntervals();
                 }
             }
             );
	panel.add(timeIntervalsButton);
	JButton computeButton = new JButton("Calculate");
	computeButton.addActionListener
            (
             new ActionListener()
             {
                 public void actionPerformed(ActionEvent e)
                 {
		     try
			 {
			     t.computeSolution();		     
			 }
		     catch(Exception f)
			 {
			     JOptionPane.showMessageDialog
				 (null,"Invalid data"); 
			 }
		     updateColors();
                 }
             }
             );
	panel.add(computeButton);
	return panel;
    }
    
    /**********************************************************************/
    
    private void initWindow()
    {
	getContentPane().removeAll();
	students = new Vector<JLabel>();
	timeIntervals = new Vector<JLabel>();
	JPanel jPanel = new JPanel();
	JScrollPane myScroll = new JScrollPane();
	myScroll.setViewportView(jPanel);
	jPanel.setLayout(new BorderLayout());
	jPanel.add(makeGrid(), BorderLayout.PAGE_START);	
	jPanel.add(addButtons(), BorderLayout.PAGE_END);
	getContentPane().add(myScroll);
    }
    
    /**********************************************************************/
    
    private void createWindow()
    {

	setTitle("Domino");        
        setResizable(true);
	setSize(1200, 1000);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);  
	initWindow();
	setVisible(true);
    }
    
    /**********************************************************************/

    private static String getFile(int mode)
    {
	Dialog p = null;
	java.awt.FileDialog f = new java.awt.FileDialog(p, "Domino", mode);	
	f.setVisible(true);
	f.dispose();
	return f.getDirectory() + f.getFile();
    }
    
    /**********************************************************************/
    
    private static void openDomino() throws Exception
    {
	int answer = JOptionPane.showConfirmDialog
	    (null, "Open an existing file ? (\"yes\" to open a file, "
	     + "\"no\" to create a new one, \"cancel\" to close the program)");
	switch(answer)
	    {
	    case JOptionPane.YES_OPTION : 
		new Domino(TimeTable.readObject(getFile(java.awt.FileDialog.LOAD)));
		break;
	    case JOptionPane.NO_OPTION :
		TimeTable t = new TimeTable();
		t.writeObject(getFile(java.awt.FileDialog.SAVE));
		new Domino(t);
		break;
	    default:
	    }
    }
    
    /**********************************************************************/
    
    public static void main(String[] args)
    {
	try
	    {
		openDomino();
	    }
	catch (Exception e)
	    {
		System.out.println(e);
		e.printStackTrace();
		System.exit(0);
	    }
    }
}
